Index: tests/creddy_tests/display.sh
===================================================================
--- tests/creddy_tests/display.sh	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/creddy_tests/display.sh	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -1,21 +1,50 @@
 #!/bin/sh
+#display.sh
 
-pwd=`pwd`
-eloc=`which creddy | sed 's/\/creddy//'`
-if [ "$eloc" = "" ]; then
-  echo "ERROR: creddy is not in the search path!!!"
-  exit 1
-fi
+. ${TESTDIR}/test_util.sh
 
-$eloc/creddy --display --show=all --cert Acme_ID.pem
-$eloc/creddy --display --show=all --cert Acme_private.pem
-$eloc/creddy --display --show=all --cert Acme_buy_rockets__Acme_preferred_customer_attr.xml
-$eloc/creddy --display --show=all --cert Acme_preferred_customer__Coyote_attr.xml
-$eloc/creddy --display --show=all --cert bad_attr.xml
+runTest "creddy_tests/display.sh" "test1"  \
+"$eloc/creddy --display --show=all --cert Acme_ID.pem" \
+0  "display an issuer cert"
 
-$eloc/creddy --display --show=all --cert not_ss.pem
-$eloc/creddy --display --show=all --cert not_ss.xml
+runTest "creddy_tests/display.sh" "test2"  \
+"$eloc/creddy --display --show=all --cert Acme_private.pem" \
+1  "display a privkey file"
 
-$eloc/creddy --display --show=all --cert ProtoGENI.xml
-$eloc/creddy --display --show=all --cert PGissuer.pem
-$eloc/creddy --display --show=all --cert priv.xml
+runTest "creddy_tests/display.sh" "test3"  \
+"$eloc/creddy --display --show=all --cert Acme_buy_rockets__Acme_preferred_customer_attr.xml" \
+0  "display an attribute cert"
+
+runTest "creddy_tests/display.sh" "test4"  \
+"$eloc/creddy --display --show=all --cert Acme_preferred_customer__Coyote_attr.xml" \
+0  "display an attribute cert"
+
+runTest "creddy_tests/display.sh" "test5"  \
+"$eloc/creddy --display --show=all --cert bad_attr.xml" \
+1  "supplied a none existing attribute cert"
+
+runTest "creddy_tests/display.sh" "test6"  \
+"$eloc/creddy --display --show=all --cert not_ss.pem" \
+0  "display an none self signed issuer cert"
+
+runTest "creddy_tests/display.sh" "test7"  \
+"$eloc/creddy --display --show=all --cert not_ss.xml" \
+0  "display a none self signed attribute cert"
+
+runTest "creddy_tests/display.sh" "test8"  \
+"$eloc/creddy --display --show=all --cert iProtoGENI.xml" \
+1  "display an expired GENI signed attribute cert"
+
+runTest "creddy_tests/display.sh" "test9"  \
+"$eloc/creddy --display --show=all --cert ProtoGENI.xml" \
+0  "FAKE:display a valid GENI signed attribute cert"
+
+runTest "creddy_tests/display.sh" "test10"  \
+"$eloc/creddy --display --show=all --cert PGissuer.pem" \
+0  "display a GENI issuer cert"
+
+runTest "creddy_tests/display.sh" "test11"  \
+"$eloc/creddy --display --show=all --cert priv.xml" \
+0  "display a GENI privilege attribute cert"
+
+
Index: tests/creddy_tests/generate.sh
===================================================================
--- tests/creddy_tests/generate.sh	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/creddy_tests/generate.sh	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -1,14 +1,21 @@
 #!/bin/sh
+#generate.sh
 
-pwd=`pwd`
-eloc=`which creddy | sed 's/\/creddy//'`
-if [ "$eloc" = "" ]; then
-  echo "ERROR: creddy is not in the search path!!!"
-  exit 1
-fi
+. ${TESTDIR}/test_util.sh
 
-$eloc/creddy --generate --cn Bigbird
-$eloc/creddy --generate --cn 12_3
-## looks like optarg just picked up the 'Bad' part
-$eloc/creddy --generate --cn Bad$name
-$eloc/creddy --generate --cn abc --cert bad_attr.xml
+runTest "creddy_tests/generate.sh" "test1", \
+"$eloc/creddy --generate --cn Bigbird"  \
+0  "simple id credential generation"
+
+runTest "creddy_tests/generate.sh" "test2", \
+"$eloc/creddy --generate --cn 12_3"  \
+0  "generate with underline in name"
+
+runTest "creddy_tests/generate.sh" "test3", \
+"$eloc/creddy --generate --cn Bad$name"  \
+0  "generate with special $ as Bad$name, later part just got dropped"
+
+runTest "creddy_tests/generate.sh" "test4", \
+"$eloc/creddy --generate --cn abc --cert gen_attr.xml"  \
+0  "generate with supplied attribute name"
+
Index: tests/creddy_tests/iProtoGENI.xml_save
===================================================================
--- tests/creddy_tests/iProtoGENI.xml_save	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/creddy_tests/iProtoGENI.xml_save	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,125 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<signed-credential xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:noNamespaceSchemaLocation="http://www.protogeni.net/resources/credential/credential.xsd" xsi:schemaLocation="http://www.protogeni.net/resources/credential/ext/policy/1 http://www.protogeni.net/resources/credential/ext/policy/1/policy.xsd">
+  <credential xml:id="refCB16DEE0B6F8507C">
+ <type>privilege</type>
+ <serial>15102</serial>
+ <owner_gid>MIIEQTCCA6qgAwIBAgICBAcwDQYJKoZIhvcNAQEEBQAwgeMxCzAJBgNVBAYTAlVT
+MQ0wCwYDVQQIEwRVdGFoMRswGQYDVQQHExJTYWx0IExha2UgU2ltIENpdHkxITAf
+BgNVBAoTGFV0YWggTmV0d29yayBTZWNvbmQgTGlmZTEeMBwGA1UECxMVQ2VydGlm
+aWNhdGUgQXV0aG9yaXR5MSkwJwYDVQQDEyBteWJvc3Muam9ubGFiLnRlc3RiZWQu
+ZW11bGFiLm5ldDE6MDgGCSqGSIb3DQEJARYrdGVzdGJlZC1vcHNAbXlvcHMuam9u
+bGFiLnRlc3RiZWQuZW11bGFiLm5ldDAeFw0xMzA1MjkxMzU5MDFaFw0xNDA1Mjkx
+MzU5MDFaMIGzMQswCQYDVQQGEwJVUzENMAsGA1UECBMEVXRhaDEhMB8GA1UEChMY
+VXRhaCBOZXR3b3JrIFNlY29uZCBMaWZlMRQwEgYDVQQLEwtqb25sYWIudXNlcjEt
+MCsGA1UEAxMkNzcxZGUzY2EtYzg2Ny0xMWUyLWIwMDEtMDAyNGU4NzkyN2ViMS0w
+KwYJKoZIhvcNAQkBFh51c2VyQGpvbmxhYi50ZXN0YmVkLmVtdWxhYi5uZXQwgZ8w
+DQYJKoZIhvcNAQEBBQADgY0AMIGJAoGBAJwMbC6tGGlqcL5Jsm65uMQyyr9epUEJ
+MidAV5pMi5I2jlwy+xfI01OT+bmq/ZqB6yLgTERAXMx/xcjA3M9zRcO2h3gK6W2R
+5Jg1sZbocHaS6Qp8nrceXUdnWJxHPxwHlkGcNZisTNrB/jzUIZvzqpHKsHj8SKAF
+ByRXo7FgeEubAgMBAAGjggEwMIIBLDAMBgNVHRMBAf8EAjAAMB0GA1UdDgQWBBQG
+0yIBzv5opmk6a6YDjdQb+jq09jCBkAYDVR0RBIGIMIGFhjR1cm46cHVibGljaWQ6
+SUROK2pvbmxhYi50ZXN0YmVkLmVtdWxhYi5uZXQrdXNlcit1c2VygR51c2VyQGpv
+bmxhYi50ZXN0YmVkLmVtdWxhYi5uZXSGLXVybjp1dWlkOjc3MWRlM2NhLWM4Njct
+MTFlMi1iMDAxLTAwMjRlODc5MjdlYjBqBggrBgEFBQcBAQReMFwwWgYUaYPMk4Co
+mMyox72xp4CAqq7XihuGQmh0dHBzOi8vbXlib3NzLmpvbmxhYi50ZXN0YmVkLmVt
+dWxhYi5uZXQ6MTIzNjkvcHJvdG9nZW5pL3htbHJwYy9zYTANBgkqhkiG9w0BAQQF
+AAOBgQBcdrf70YPbnIoQvlUdX/rBRh4Xxo55uqJ8kZEdnIKcN/OaiwYkVuPHWl/k
+qxmTnB707+e9uhhszNhQLuWnXuD+w08gcBUNQiUxF9MjW1nw1LrLQjvShetJKVs6
+Uut/UnbDbeS05LkhQw0I1Q75alZcY6r5qRZkmcbDisR8IRHjJg==
+</owner_gid>
+ <owner_urn>urn:publicid:IDN+jonlab.testbed.emulab.net+user+user</owner_urn>
+ <target_gid>MIID/jCCA2egAwIBAgICA/gwDQYJKoZIhvcNAQEEBQAwgeMxCzAJBgNVBAYTAlVT
+MQ0wCwYDVQQIEwRVdGFoMRswGQYDVQQHExJTYWx0IExha2UgU2ltIENpdHkxITAf
+BgNVBAoTGFV0YWggTmV0d29yayBTZWNvbmQgTGlmZTEeMBwGA1UECxMVQ2VydGlm
+aWNhdGUgQXV0aG9yaXR5MSkwJwYDVQQDEyBteWJvc3Muam9ubGFiLnRlc3RiZWQu
+ZW11bGFiLm5ldDE6MDgGCSqGSIb3DQEJARYrdGVzdGJlZC1vcHNAbXlvcHMuam9u
+bGFiLnRlc3RiZWQuZW11bGFiLm5ldDAeFw0xMzA0MjIxNTE1NDNaFw0xODEwMTMx
+NjE1NDNaMIG+MQswCQYDVQQGEwJVUzENMAsGA1UECBMEVXRhaDEhMB8GA1UEChMY
+VXRhaCBOZXR3b3JrIFNlY29uZCBMaWZlMRIwEAYDVQQLEwlqb25sYWIuc2ExLTAr
+BgNVBAMTJGUxYTIxMzNkLWFiNjctMTFlMi1iMDAxLTAwMjRlODc5MjdlYjE6MDgG
+CSqGSIb3DQEJARYrdGVzdGJlZC1vcHNAbXlvcHMuam9ubGFiLnRlc3RiZWQuZW11
+bGFiLm5ldDCBnzANBgkqhkiG9w0BAQEFAAOBjQAwgYkCgYEAzYZo6Dq9Yo+LZ/Ah
+M2f6r/jkO/tJow5h6A4F4kqZfHIS1lyN/zICra47qjHpgrBC3npR5+ibr4AosC4m
+wDo09yFHbS0CUSIGuemt7Nnt/siD8ULqXwYMwHHDhr+wQnqgjiPoo0FT69lbfiQ3
+P1IH6TVn8j5vK/5i1PtolKqUg5MCAwEAAaOB4zCB4DAdBgNVHQ4EFgQUbXWxdwVR
+Ouopn6qnsRp9jaY9nBYwQgYDVR0RBDswOYY3dXJuOnB1YmxpY2lkOklETitqb25s
+YWIudGVzdGJlZC5lbXVsYWIubmV0K2F1dGhvcml0eStzYTAPBgNVHRMBAf8EBTAD
+AQH/MGoGCCsGAQUFBwEBBF4wXDBaBhRpg8yTgKiYzKjHvbGngICqrteKG4ZCaHR0
+cHM6Ly9teWJvc3Muam9ubGFiLnRlc3RiZWQuZW11bGFiLm5ldDoxMjM2OS9wcm90
+b2dlbmkveG1scnBjL3NhMA0GCSqGSIb3DQEBBAUAA4GBAHUtR537wn94Em+BJUS4
+lb6qQ/mDG49l1K12XJghyKU40pQCxRKlp4EWScghgtwcpBTaCcA3+ZOgkdwnHXLx
+pCabA69clBKdncqaaUzSCx4AGjGe9yMX6WliBvvh2dODQZeFlK7C9B7mTvkTFv4Z
+iMdQbxu/Fh8LdtU+ymuXekid
+</target_gid>
+ <target_urn>urn:publicid:IDN+jonlab.testbed.emulab.net+authority+sa</target_urn>
+ <uuid>9bc8ec4e-c869-11e2-b001-0024e87927eb</uuid>
+ <expires>2013-05-30T14:11:08Z</expires>
+  <privileges>
+<privilege><name>*</name><can_delegate>1</can_delegate></privilege>
+</privileges></credential>
+  <signatures>
+    <Signature xmlns="http://www.w3.org/2000/09/xmldsig#" xml:id="Sig_refCB16DEE0B6F8507C">
+ <SignedInfo>
+  <CanonicalizationMethod Algorithm="http://www.w3.org/TR/2001/REC-xml-c14n-20010315"/>
+  <SignatureMethod Algorithm="http://www.w3.org/2000/09/xmldsig#rsa-sha1"/>
+  <Reference URI="#refCB16DEE0B6F8507C">
+    <Transforms>
+      <Transform Algorithm="http://www.w3.org/2000/09/xmldsig#enveloped-signature"/>
+    </Transforms>
+    <DigestMethod Algorithm="http://www.w3.org/2000/09/xmldsig#sha1"/>
+    <DigestValue>9/uW8NR0sHZpLAPzxZ32SOLAZhY=</DigestValue>
+    </Reference>
+ </SignedInfo>
+ <SignatureValue>UfAUZ5RyncNw+YWJOAbmfnOYbpWxeyVLDZ9Kg7yw4idRUE0/CnL0bNkUAT5g2IYF
+W/kKxooWz/1P15/EOtDE+OYJCdnWwR1iEoWoxyQayP94bygAZ7WiLvrwhoTMQ01+
+lvnjClLyTAibpeWp2Uql1KRSX8TFrEKXsKqPt/vhOls=</SignatureValue>
+ <KeyInfo>
+  <X509Data>
+   
+   
+   
+  <X509Certificate>MIID/jCCA2egAwIBAgICA/gwDQYJKoZIhvcNAQEEBQAwgeMxCzAJBgNVBAYTAlVT
+MQ0wCwYDVQQIEwRVdGFoMRswGQYDVQQHExJTYWx0IExha2UgU2ltIENpdHkxITAf
+BgNVBAoTGFV0YWggTmV0d29yayBTZWNvbmQgTGlmZTEeMBwGA1UECxMVQ2VydGlm
+aWNhdGUgQXV0aG9yaXR5MSkwJwYDVQQDEyBteWJvc3Muam9ubGFiLnRlc3RiZWQu
+ZW11bGFiLm5ldDE6MDgGCSqGSIb3DQEJARYrdGVzdGJlZC1vcHNAbXlvcHMuam9u
+bGFiLnRlc3RiZWQuZW11bGFiLm5ldDAeFw0xMzA0MjIxNTE1NDNaFw0xODEwMTMx
+NjE1NDNaMIG+MQswCQYDVQQGEwJVUzENMAsGA1UECBMEVXRhaDEhMB8GA1UEChMY
+VXRhaCBOZXR3b3JrIFNlY29uZCBMaWZlMRIwEAYDVQQLEwlqb25sYWIuc2ExLTAr
+BgNVBAMTJGUxYTIxMzNkLWFiNjctMTFlMi1iMDAxLTAwMjRlODc5MjdlYjE6MDgG
+CSqGSIb3DQEJARYrdGVzdGJlZC1vcHNAbXlvcHMuam9ubGFiLnRlc3RiZWQuZW11
+bGFiLm5ldDCBnzANBgkqhkiG9w0BAQEFAAOBjQAwgYkCgYEAzYZo6Dq9Yo+LZ/Ah
+M2f6r/jkO/tJow5h6A4F4kqZfHIS1lyN/zICra47qjHpgrBC3npR5+ibr4AosC4m
+wDo09yFHbS0CUSIGuemt7Nnt/siD8ULqXwYMwHHDhr+wQnqgjiPoo0FT69lbfiQ3
+P1IH6TVn8j5vK/5i1PtolKqUg5MCAwEAAaOB4zCB4DAdBgNVHQ4EFgQUbXWxdwVR
+Ouopn6qnsRp9jaY9nBYwQgYDVR0RBDswOYY3dXJuOnB1YmxpY2lkOklETitqb25s
+YWIudGVzdGJlZC5lbXVsYWIubmV0K2F1dGhvcml0eStzYTAPBgNVHRMBAf8EBTAD
+AQH/MGoGCCsGAQUFBwEBBF4wXDBaBhRpg8yTgKiYzKjHvbGngICqrteKG4ZCaHR0
+cHM6Ly9teWJvc3Muam9ubGFiLnRlc3RiZWQuZW11bGFiLm5ldDoxMjM2OS9wcm90
+b2dlbmkveG1scnBjL3NhMA0GCSqGSIb3DQEBBAUAA4GBAHUtR537wn94Em+BJUS4
+lb6qQ/mDG49l1K12XJghyKU40pQCxRKlp4EWScghgtwcpBTaCcA3+ZOgkdwnHXLx
+pCabA69clBKdncqaaUzSCx4AGjGe9yMX6WliBvvh2dODQZeFlK7C9B7mTvkTFv4Z
+iMdQbxu/Fh8LdtU+ymuXekid</X509Certificate>
+<X509SubjectName>emailAddress=testbed-ops@myops.jonlab.testbed.emulab.net,CN=e1a2133d-ab67-11e2-b001-0024e87927eb,OU=jonlab.sa,O=Utah Network Second Life,ST=Utah,C=US</X509SubjectName>
+<X509IssuerSerial>
+<X509IssuerName>emailAddress=testbed-ops@myops.jonlab.testbed.emulab.net,CN=myboss.jonlab.testbed.emulab.net,OU=Certificate Authority,O=Utah Network Second Life,L=Salt Lake Sim City,ST=Utah,C=US</X509IssuerName>
+<X509SerialNumber>1016</X509SerialNumber>
+</X509IssuerSerial>
+</X509Data>
+  <KeyValue>
+<RSAKeyValue>
+<Modulus>
+zYZo6Dq9Yo+LZ/AhM2f6r/jkO/tJow5h6A4F4kqZfHIS1lyN/zICra47qjHpgrBC
+3npR5+ibr4AosC4mwDo09yFHbS0CUSIGuemt7Nnt/siD8ULqXwYMwHHDhr+wQnqg
+jiPoo0FT69lbfiQ3P1IH6TVn8j5vK/5i1PtolKqUg5M=
+</Modulus>
+<Exponent>
+AQAB
+</Exponent>
+</RSAKeyValue>
+</KeyValue>
+ </KeyInfo>
+</Signature>
+  </signatures>
+</signed-credential>
+
Index: tests/creddy_tests/keyid.sh
===================================================================
--- tests/creddy_tests/keyid.sh	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/creddy_tests/keyid.sh	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -1,20 +1,41 @@
 #!/bin/sh
+# keyid.sh
 
-pwd=`pwd`
-eloc=`which creddy | sed 's/\/creddy//'`
-if [ "$eloc" = "" ]; then
-  echo "ERROR: creddy is not in the search path!!!"
-  exit 1
-fi
+. ${TESTDIR}/test_util.sh
 
-$eloc/creddy --keyid --cert Acme_ID.pem
-$eloc/creddy --keyid --cert Acme_private.pem
-$eloc/creddy --keyid --cert Acme_buy_rockets__Acme_preferred_customer_attr.xml
-$eloc/creddy --keyid --cert bad_attr.xml
+runTest "creddy_tests/keyid.sh" "test1"  \
+"$eloc/creddy --keyid --cert Acme_ID.pem" \
+0  "supplied with good identity cert"
 
-$eloc/creddy --keyid --cert not_ss.pem
-$eloc/creddy --keyid --cert not_ss.xml
-$eloc/creddy --keyid --cert priv.xml
-$eloc/creddy --keyid --cert PGissuer.pem
-$eloc/creddy --keyid --cert ProtoGENI.xml
+runTest "creddy_tests/keyid.sh" "test2"  \
+"$eloc/creddy --keyid --cert Acme_private.pem" \
+1  "supplied with privkey"
 
+runTest "creddy_tests/keyid.sh" "test3"  \
+"$eloc/creddy --keyid --cert Acme_buy_rockets__Acme_preferred_customer_attr.xml" \
+1  "supplied with attribute cert instead"
+
+runTest "creddy_tests/keyid.sh" "test4"  \
+"$eloc/creddy --keyid --cert bad_attr.xml" \
+1  "supplied with non existing attribute cert"
+
+runTest "creddy_tests/keyid.sh" "test5"  \
+"$eloc/creddy --keyid --cert not_ss.pem" \
+0  "supplied with good none self signed identity cert"
+
+runTest "creddy_tests/keyid.sh" "test6"  \
+"$eloc/creddy --keyid --cert not_ss.xml" \
+1  "supplied with none self signed attribute cert"
+
+runTest "creddy_tests/keyid.sh" "test7"  \
+"$eloc/creddy --keyid --cert priv.xml" \
+1  "supplied with GENI privilege attribute cert"
+
+runTest "creddy_tests/keyid.sh" "test8"  \
+"$eloc/creddy --keyid --cert PGissuer.pem" \
+0  "supplied with GENI issuer cert"
+
+runTest "creddy_tests/keyid.sh" "test9"  \
+"$eloc/creddy --keyid --cert ProtoGENI.xml" \
+1  "supplied with GENI issued attribute cert"
+
Index: tests/creddy_tests/roles.sh
===================================================================
--- tests/creddy_tests/roles.sh	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/creddy_tests/roles.sh	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -1,13 +1,35 @@
 #!/bin/sh
+#roles.sh
 
-pwd=`pwd`
-eloc=`which creddy | sed 's/\/creddy//'`
-if [ "$eloc" = "" ]; then
-  echo "ERROR: creddy is not in the search path!!!"
-  exit 1
-fi
+. ${TESTDIR}/test_util.sh
 
-$eloc/creddy --roles --cert Acme_ID.pem
-$eloc/creddy --roles --cert Acme_private.pem
-$eloc/creddy --roles --cert Acme_buy_rockets__Acme_preferred_customer_attr.xml
-$eloc/creddy --roles --cert bad_attr.xml
+runTest "creddy_tests/role.sh" "test1"  \
+"$eloc/creddy --roles --cert Acme_ID.pem" \
+ 1  "supplied  with a issuer cert"
+
+runTest "creddy_tests/role.sh" "test2"  \
+"$eloc/creddy --roles --cert Acme_private.pem" \
+ 1  "supplied with a privkey"
+
+runTest "creddy_tests/role.sh" "test3"  \
+"$eloc/creddy --roles --cert Acme_buy_rockets__Acme_preferred_customer_attr.xml" \
+ 0  "supplied with right attribute cert"
+
+runTest "creddy_tests/role.sh" "test4"  \
+"$eloc/creddy --roles --cert bad_attr.xml" \
+ 1  "supplied with a none existing cert"
+
+runTest "creddy_tests/role.sh" "test5"  \
+"$eloc/creddy --roles --cert priv.xml" \
+ 0  "supplied with a GENI priviledge cert"
+
+runTest "creddy_tests/role.sh" "test6"  \
+"$eloc/creddy --roles --cert not_ss.xml" \
+ 0  "supplied with a none self signed attribute cert"
+
+runTest "creddy_tests/role.sh" "test7"  \
+"$eloc/creddy --roles --cert iProtoGENI.xml" \
+ 1  "supplied with an expired  GENI signed attribute cert"
+
+
+
Index: tests/creddy_tests/setup.sh
===================================================================
--- tests/creddy_tests/setup.sh	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/creddy_tests/setup.sh	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -4,15 +4,11 @@
 #Acme.preferred_customer <- Coyote
 
-rm -rf *.pem *.xml *.out
+. ${TESTDIR}/test_util.sh
 
-pwd=`pwd`
-eloc=`which creddy | sed 's/\/creddy//'`
-if [ "$eloc" = "" ]; then
-  echo "ERROR: creddy is not in the search path!!!"
-  exit 1
-fi
+$eloc/creddy --generate --cn Acme 1>/dev/null 2>&1
+$eloc/creddy --generate --cn Coyote 1>/dev/null 2>&1
 
-$eloc/creddy --generate --cn Acme
-$eloc/creddy --generate --cn Coyote
+$eloc/creddy --generate --cn Bigbird 1>/dev/null 2>& 1
+$eloc/creddy --generate --cn Coyote 1>/dev/null 2>& 1
 
 $eloc/creddy --attribute \
@@ -30,4 +26,6 @@
 cp priv.xml_save priv.xml
 cp PGissuer.pem_save PGissuer.pem
-cp ProtoGENI.xml_save ProtoGENI.xml
+cp iProtoGENI.xml_save iProtoGENI.xml
+## waiting for a real valid one..
+cp iProtoGENI.xml_save ProtoGENI.xml
 
Index: tests/creddy_tests/verify.sh
===================================================================
--- tests/creddy_tests/verify.sh	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/creddy_tests/verify.sh	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -1,24 +1,60 @@
 #!/bin/sh
-#creddy --verify --cert <cert> [ --attrcert <cert> ]
+#creddy --verify --cert <issuer> [ --attrcert <cert> ]
+#verify.sh
 
-pwd=`pwd`
-eloc=`which creddy | sed 's/\/creddy//'`
-if [ "$eloc" = "" ]; then
-  echo "ERROR: creddy is not in the search path!!!"
-  exit 1
-fi
+. ${TESTDIR}/test_util.sh
 
-$eloc/creddy --verify --cert Coyote_ID.pem --attrcert Acme_buy_rockets__Acme_preferred_customer_attr.xml
-$eloc/creddy --verify --cert Acme_ID.pem --attrcert Acme_buy_rockets__Acme_preferred_customer_attr.xml
+runXTest "creddy_tests/verify.sh" "test1" \
+"$eloc/creddy --verify --cert Coyote_ID.pem --attrcert Acme_buy_rockets__Acme_preferred_customer_attr.xml" \
+0  "have mismatched principals" "ID and attr are still valid but differ in principals"
 
-$eloc/creddy --verify --cert Acme_private.pem
-$eloc/creddy --verify --cert Acme_ID.pem --attrcert bad_attr.xml
-$eloc/creddy --verify --cert Acme_buy_rockets__Acme_preferred_customer_attr.xml
-$eloc/creddy --verify --cert bad_attr.xml
-$eloc/creddy --verify --cert Coyote_ID.pem
+runTest "creddy_tests/verify.sh" "test2" \
+"$eloc/creddy --verify --cert Acme_ID.pem --attrcert Acme_buy_rockets__Acme_preferred_customer_attr.xml" \
+0  "matching principal and attribute"
 
-$eloc/creddy --verify --cert not_ss.pem
-$eloc/creddy --verify --cert not_ss.xml
-$eloc/creddy --verify --cert priv.xml
-$eloc/creddy --verify --cert PGissuer.pem
-$eloc/creddy --verify --cert ProtoGENI.xml
+runTest "creddy_tests/verify.sh" "test3" \
+"$eloc/creddy --verify --cert Acme_private.pem" \
+1 "verify with just a privkey"
+
+## this should really fail with a specific error code, 
+runTest "creddy_tests/verify.sh" "test4" \
+"$eloc/creddy --verify --cert Acme_ID.pem --attrcert bad_attr.xml" \
+0  "verify with non existing attribute, but still pass because issuer is okay"
+
+runTest "creddy_tests/verify.sh" "test5"  \
+"$eloc/creddy --verify --cert Acme_buy_rockets__Acme_preferred_customer_attr.xml " \
+1  "verify with just an attribute"
+
+runTest "creddy_tests/verify.sh" "test6"  \
+"$eloc/creddy --verify --cert bad_attr.xml" \
+1  "verify with just a none existing attribute"
+
+runTest "creddy_tests/verify.sh" "test7"  \
+"$eloc/creddy --verify --cert Coyote_ID.pem" \
+0  "verify just an issuer"
+
+runTest "creddy_tests/verify.sh" "test8"  \
+"$eloc/creddy --verify --cert not_ss.pem" \
+0  "verify just a none self signed principal pem"
+
+runTest "creddy_tests/verify.sh" "test9" \
+"$eloc/creddy --verify --attrcert not_ss.xml" \
+1  "verify just a none self signed attribute"
+
+runTest "creddy_tests/verify.sh" "test10" \
+"$eloc/creddy --verify --cert not_ss.xml" \
+1  "incorrectly trying to verify a none self signed attribute as an issuer cert"
+
+runTest "creddy_tests/verify.sh" "test11"  \
+"$eloc/creddy --verify --cert priv.xml" \
+1  "trying to verify GENI privilege attribute as an issuer cert"
+
+runTest "creddy_tests/verify.sh" "test12"  \
+"$eloc/creddy --verify --cert PGissuer.pem" \
+0  "verify a GENI's issuer pem"
+
+runTest "creddy_tests/verify.sh" "test13"  \
+"$eloc/creddy --verify --cert ProtoGENI.xml" \
+1  "incorrectly trying to verify a GENI issued attribute as issuer cert"
+
+
Index: tests/example_scripts/Makefile.am
===================================================================
--- tests/example_scripts/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/example_scripts/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,40 @@
+#
+# example_scripts
+#
+INCLUDES = -I$(abs_top_srcdir)/libabac
+LDADD = $(abs_top_builddir)/libabac/libabac.la
+
+DIRECTORY = c perl python wiki
+
+.PHONY : runcheck clean-local
+
+all: runcheck
+
+clean-local:
+	@for i in $(DIRECTORY); do \
+	  here=`pwd`; \
+	  cd $$i; \
+	  make -s clean; \
+	  cd $$here; \
+	done
+	@rm -rf result error
+
+runcheck:
+	@echo 'running libabac SCRIPT testing...' | tee result
+	@touch error;
+	@for i in $(DIRECTORY); do \
+	  here=`pwd`; \
+	  cd $$i; \
+	  printf "\n ==> RUN on %s\n" "$$i" >> $$here/result ; \
+	  make -s |tee -a $$here/result |grep BAD >> $$here/error; \
+	  cd $$here; \
+	done
+	@if test -f error ; \
+	  then \
+	    (if test `cat error | wc -l ` -eq 0 ; \
+	      then echo "   PASSED"; \
+	      else (echo "   ERROR!!!"; cat error;); \
+	    fi); \
+	  else echo "   PASSED"; \
+	fi
+
Index: tests/example_scripts/c/Makefile.am
===================================================================
--- tests/example_scripts/c/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/example_scripts/c/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,77 @@
+#
+# example_scripts/c
+#
+
+.PHONY: clean-local 
+
+INCLUDES = -I$(abs_top_srcdir)/libabac
+LDADD = $(abs_top_builddir)/libabac/libabac.la
+CREDDY_ENV = CREDDY_LOCATION=$(abs_top_builddir)/creddy
+PROVER_ENV = PROVER_LOCATION=$(abs_top_builddir)/libabac
+TEST_ENV = TESTDIR=$(abs_top_builddir)/tests
+MY_ENV = env $(CREDDY_ENV) $(PROVER_ENV) $(TEST_ENV) LD_LIBRARY_PATH=$(abs_top_builddir)/libabac/.libs
+
+LDFLAGS =-L$(abs_top_builddir)/libabac/.libs -labac -lm -lpthread -Wl,-rpath
+
+all: attr prove 
+
+abac_attr.o: abac_attr.c
+	@gcc -g $(INCLUDES) -c abac_attr.c -o abac_attr.o
+
+abac_attr: abac_attr.o
+	@gcc -g -o abac_attr abac_attr.o $(LDFLAGS)
+
+abac_prover.o: abac_prover.c
+	@gcc -g $(INCLUDES) -c abac_prover.c -o abac_prover.o
+
+abac_prover: abac_prover.o
+	@gcc -g -o abac_prover abac_prover.o $(LDFLAGS)
+
+tchunk: tchunk.c
+	gcc -g $(INCLUDES) -c tchunk.c -o tchunk.o
+	gcc -g -o tchunk tchunk.o $(LDFLAGS)
+	./tchunk 0 IceCream_ID.pem IceCream_private.pem
+	./tchunk 1 IceCream_ID.pem IceCream_private.pem
+
+tt: tbasic.c
+	gcc -g $(INCLUDES) -c tbasic.c -o tbasic.o
+	gcc -g -o tt tbasic.o $(LDFLAGS)
+	./tt
+
+clean-local:
+	@rm -rf abac_attr.o abac_attr *.pem *.xml abac_prover.o 
+	@rm -rf abac_prover *.log 
+	@rm -rf tt tbasic.o tbasic
+
+setup2: abac_attr abac_prover abac_attr_partial
+
+attr: 
+	@echo '---running (c) attr script'
+	@$(MY_ENV) ./setup.sh 1>/dev/null 2>&1
+	@make abac_attr
+	@(rc=`$(MY_ENV) ./abac_attr IceCream_ID.pem  IceCream_private.pem IceCream_attr.xml Chocolate_ID.pem 2>/dev/null 2>/dev/null | grep "attr success"` ; \
+	if [ -z "$$rc" ]; then \
+	  echo "BAD:example_scripts/c/abac_attr:using libabac c to make attributes"; \
+	else \
+	  echo "GOOD:example_scripts/c/abac_attr:using libabac c to make attributes"; \
+	fi)
+
+
+prove: abac_prover 
+	@echo '---running (c) prover script'
+	@$(MY_ENV) ./setup.sh 1>/dev/null 2>&1
+	@make abac_attr
+	@$(MY_ENV) ./abac_attr IceCream_ID.pem  IceCream_private.pem IceCream_attr.xml Chocolate_ID.pem 1>/dev/null 2>&1
+	(rc=`$(MY_ENV) ./run_prover | grep "prover success" ` ; \
+	if [ -z "$$rc" ]; then \
+	  echo "BAD:example_scripts/c/abac_prover:using libabac c to make a prover"; \
+	else \
+	  echo "GOOD:example_scripts/c/abac_prover:using libabac c to make a prover"; \
+	fi)
+
+
+
+mattr: attr.c
+	gcc -g -o mattr attr.c $(LDFLAGS)
+mload: loader.c
+	gcc -g -o mload loader.c $(LDFLAGS)
Index: tests/example_scripts/c/run_prover
===================================================================
--- tests/example_scripts/c/run_prover	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/example_scripts/c/run_prover	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -1,16 +1,16 @@
 #!/bin/sh
 
+. ${TESTDIR}/test_util.sh
+
 keystore=`pwd`
-pID=`creddy --keyid --cert ${keystore}/IceCream_ID.pem`
-cID=`creddy --keyid --cert ${keystore}/Chocolate_ID.pem`
+pID=`$eloc/creddy --keyid --cert ${keystore}/IceCream_ID.pem`
+cID=`$eloc/creddy --keyid --cert ${keystore}/Chocolate_ID.pem`
 
 role="${pID}.delicious"
 principal="${cID}"
 
-if [ $1 = "debug" ]; then
-    echo "$keystore" "$role" "$principal"
-    gdb ./abac_prover
-else
-    ./abac_prover "$keystore" "$role" "$principal"
-fi
+#    echo "$keystore" "$role" "$principal"
+#    gdb ./abac_prover
 
+./abac_prover "$keystore" "$role" "$principal"
+
Index: tests/example_scripts/c/setup.sh
===================================================================
--- tests/example_scripts/c/setup.sh	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/example_scripts/c/setup.sh	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,10 @@
+#!/bin/sh
+# setup.sh
+
+. ${TESTDIR}/test_util.sh
+
+$eloc/creddy --generate --cn IceCream
+$eloc/creddy --generate --cn Chocolate
+
+
+
Index: tests/example_scripts/perl/Makefile.am
===================================================================
--- tests/example_scripts/perl/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/example_scripts/perl/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,65 @@
+#
+# example_scripts/perl
+#
+
+.PHONY: clean-local
+
+INCLUDES = -I$(abs_top_srcdir)/libabac
+LDADD = $(abs_top_builddir)/libabac/libabac.la
+CREDDY_ENV = CREDDY_LOCATION=$(abs_top_builddir)/creddy
+PROVER_ENV = PROVER_LOCATION=$(abs_top_builddir)/libabac
+TEST_ENV = TESTDIR=$(abs_top_builddir)/tests
+PERL_ENV = PERLLIB=$(abs_top_builddir)/swig/perl:$(abs_top_builddir)/swig/perl/.libs
+MY_ENV = env $(CREDDY_ENV) $(PROVER_ENV) $(TEST_ENV) $(PERL_ENV)
+
+all: run bad prove
+
+clean-local:
+	@rm -rf *.pem *.xml 
+
+run: 
+	echo '---running (perl) id script'
+	make clean
+	$(MY_ENV) ./setup.sh 1>/dev/null 2>&1
+	(rc=`$(MY_ENV) ./abac_keyid.pl IceCream_ID.pem | grep OKAY` ; \
+	if [ -z "$$rc" ]; then \
+	  echo "BAD:example_scripts/perl/abac_keyid.pl:using libabac perl to make principal"; \
+	else \
+	  echo "GOOD:example_scripts/perl/abac_keyid.pl:using libabac perl to make principal"; \
+	fi)
+
+bad: 
+	echo '---running (perl) id2 script, expected failure'
+	make clean
+	$(MY_ENV) ./setup.sh 1>/dev/null 2>&1
+	(rc=`$(MY_ENV) ./abac_keyid.pl IceCream_private.pem | grep "std::invalid_argument"`; \
+	if [ -z "$$rc" ]; then \
+	  echo "BAD:example_scripts/perl/abac_keyid.pl:supplied with just privkey"; \
+	else \
+	  echo "GOOD:example_scripts/perl/abac_keyid.pl:supplied with just privkey"; \
+	fi)
+
+attr: 
+	echo '---running (perl) attr script'
+	make clean
+	$(MY_ENV) ./setup.sh 1>/dev/null 2>&1
+	(rc=`$(MY_ENV) ./run_attr | grep chocolate` ; \
+	if [ -z "$$rc" ]; then \
+	  echo "BAD:example_scripts/perl/abac_attr.pl:creating attribute"; \
+	else \
+	  echo "GOOD:example_scripts/perl/abac_keyid.pl:creating attribute"; \
+	fi)
+
+prove: 
+	echo '---running (perl) attr script'
+	make clean
+	$(MY_ENV) ./setup.sh 1>/dev/null 2>&1
+	$(MY_ENV) ./run_attr 1>/dev/null 2>&1
+	(rc=`$(MY_ENV) ./run_prover | grep Success` ; \
+	if [ -z "$$rc" ]; then \
+	  echo "BAD:example_scripts/perl/abac_prover.pl:prover in perl"; \
+	else \
+	  echo "GOOD:example_scripts/perl/abac_prover.pl:prover in perl"; \
+	fi)
+
+
Index: tests/example_scripts/perl/run_prover
===================================================================
--- tests/example_scripts/perl/run_prover	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/example_scripts/perl/run_prover	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -1,7 +1,9 @@
 #!/bin/sh
 
+. ${TESTDIR}/test_util.sh
+
 keystore=`pwd`
-pID=`creddy --keyid --cert ${keystore}/IceCream_ID.pem`
-cID=`creddy --keyid --cert ${keystore}/Chocolate_ID.pem`
+pID=`$eloc/creddy --keyid --cert ${keystore}/IceCream_ID.pem`
+cID=`$eloc/creddy --keyid --cert ${keystore}/Chocolate_ID.pem`
 
 role="${pID}.delicious"
Index: tests/example_scripts/perl/setup.sh
===================================================================
--- tests/example_scripts/perl/setup.sh	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/example_scripts/perl/setup.sh	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,10 @@
+#!/bin/sh
+# setup.sh
+
+. ${TESTDIR}/test_util.sh
+
+$eloc/creddy --generate --cn IceCream
+$eloc/creddy --generate --cn Chocolate
+
+
+
